<?php
require_once('concat_config.php');
mysql_connect($db_host, $db_user, $db_pw);
mysql_select_db($db_db);

// creates the where-clause for the list-query
function listQuery($field, $value) {
	$where = '(' . $field . ' LIKE \'%,' . $value . ',%\' OR  ' .
		$field . ' LIKE \'' . $value . ',%\' OR ' .
		$field . ' LIKE \'%,' . $value . '\' OR ' .
		$field . '=\'' . $value . '\')';
	return $where;
}
// creates the where-clause for the concat-query
function concatQuery($field, $value) {
	$where = 'concat(\',\', ' . $field . ', \',\') LIKE \'%,' . $value . ',%\'';
	return $where;
}
// creates the where-clause for the find_in_set-query
function findInSetQuery($field, $value) {
	$where = 'find_in_set(\'' . $value . '\',' . $field . ')';
	return $where;
}
// writes the infos into a log-file or into stdOut
function writeOutput($value, $writeLog = FALSE, $file = 'test.log') {
	if($writeLog) {
		file_put_contents($file, $value . chr(10));
	}
	else {
		echo $value . chr(10);
	}
}

// the main testing function
function checkDB($count, $checkTables = array('list_test', 'list_test_index'), $writeLog = FALSE, $logFile = 'test.log') {
	$valueArray = array();
	for($i = 0; $i < $count; $i++) {
		$valueArray[] = rand(1,2000);
	}
	$listArrayList = array();
	$listArrayConcat = array();
	$listArrayFindInSet = array();
	foreach($valueArray as $value) {
		$listArrayList[] = listQuery('list', $value);
		$listArrayConcat[] = concatQuery('list', $value);
		$listArrayFindInSet[] = findInSetQuery('list', $value);
	}

	foreach($checkTables as $table) {
		writeOutput(chr(10) . 'TABELLE: ' . $table . chr(10), $writeLog, $logFile);

		writeOutput('LIKE-ABFRAGE: ', $writeLog, $logFile);
		$countListQuery = array();
		$start = explode(' ', microtime());
		foreach($listArrayList as $value) {
			$query = 'select uid from '.$table.' where '.$value;
			$res = mysql_query($query);
			$countListQuery[] = mysql_num_rows($res);
		}
		$end = explode(' ', microtime());

		writeOutput(chr(9) . 'STARTZEIT: ' . $start[1] . ' ' . $start[0], $writeLog, $logFile);
		writeOutput(chr(9) . 'ENDZEIT  : ' . $end[1] . ' ' . $end[0], $writeLog, $logFile);
		$diff = ($end[0] > $start[0]) ? array(($end[0] - $start[0]), ($end[1] - $start[1])) : array((($end[0] + 1) - $start[0]), ($end[1] - $start[1] - 1));
		writeOutput(chr(9) . 'DIFFERENZ: ' . $diff[1] . ' ' . $diff[0] . chr(10), $writeLog, $logFile);

		writeOutput('CONCAT-ABFRAGE: ', $writeLog, $logFile);
		$countConcatQuery = array();
		$start = explode(' ', microtime());
		foreach($listArrayConcat as $value) {
			$query = 'select uid from '.$table.' where '.$value;
			$res = mysql_query($query);
			$countConcatQuery[] = mysql_num_rows($res);
		}
		$end = explode(' ', microtime());

		writeOutput(chr(9) . 'STARTZEIT: ' . $start[1] . ' ' . $start[0], $writeLog, $logFile);
		writeOutput(chr(9) . 'ENDZEIT  : ' . $end[1] . ' ' . $end[0], $writeLog, $logFile);
		$diff = ($end[0] > $start[0]) ? array(($end[0] - $start[0]), ($end[1] - $start[1])) : array((($end[0] + 1) - $start[0]), ($end[1] - $start[1] - 1));
		writeOutput(chr(9) . 'DIFFERENZ: ' . $diff[1] . ' ' . $diff[0] . chr(10), $writeLog, $logFile);

		writeOutput('FIND_IN_SET-ABFRAGE: ', $writeLog, $logFile);
		$countFindInSetQuery = array();
		$start = explode(' ', microtime());
		foreach($listArrayFindInSet as $value) {
			$query = 'select uid from '.$table.' where '.$value;
			$res = mysql_query($query);
			$countFindInSetQuery[] = mysql_num_rows($res);
		}
		$end = explode(' ', microtime());

		writeOutput(chr(9) . 'STARTZEIT: ' . $start[1] . ' ' . $start[0], $writeLog, $logFile);
		writeOutput(chr(9) . 'ENDZEIT  : ' . $end[1] . ' ' . $end[0], $writeLog, $logFile);
		$diff = ($end[0] > $start[0]) ? array(($end[0] - $start[0]), ($end[1] - $start[1])) : array((($end[0] + 1) - $start[0]), ($end[1] - $start[1] - 1));
		writeOutput(chr(9) . 'DIFFERENZ: ' . $diff[1] . ' ' . $diff[0] . chr(10), $writeLog, $logFile);

		$checkResultCount = TRUE;
		for($i = 0; $i < count($countListQuery); $i++) {
			$checkResultCount = (boolean)($countListQuery[$i] == $countConcatQuery[$i] && $countListQuery[$i] == $countFindInSetQuery[$i] && $checkResultCount);
		}
		writeOutput('ERGEBNIS-CHECK: ' . ($checkResultCount ? 'ERFOLG' : 'FEHLER') . chr(10), $writeLog, $logFile);
	}
}

//START
checkDB($select_counts, $checkTables, $writeLog, $logFile);

?>